unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls,
  Graphics, Dialogs, StdCtrls, Process;

type

  { TPipeThread }

  TPipeThread = class(TThread)
  private
    FProc: TProcess;
    FS: String;
    FSL: TStringList;
    procedure Show;
  public
    constructor Create;
    destructor Destroy; override;
  protected
    procedure Execute; override;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FPipeThread: TPipeThread;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FPipeThread:=TPipeThread.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FPipeThread.Terminate;
end;

{ TForm1 }

{ TPipeThread }

procedure TPipeThread.Show;
var
  i: Integer;
begin
  FSL.Text:=FS;
  for i:=0 to FSL.Count - 1 do
    Form1.Memo1.Lines.Add(FSL[i]);
end;

constructor TPipeThread.Create;
begin
  inherited Create(False);
  FreeOnTerminate:=True;
  FProc:=TProcess.Create(nil);
  FSL:=TStringList.Create;
  try
    FProc.Executable := 'OutPut.exe';
    FProc.Options    := [poUsePipes, poStderrToOutPut, poNoConsole];
    FProc.Execute;
  finally
  end;
end;

destructor TPipeThread.Destroy;
begin
  FProc.Terminate(0);
  FSL.Free;
  FProc.Free;
  inherited Destroy;
end;

procedure TPipeThread.Execute;
var
  aSize: Int64;
begin
  while not terminated do begin
    aSize:=FProc.Output.NumBytesAvailable;
    if aSize > 0 then begin
      SetLength(FS, aSize);
      aSize:=FProc.Output.Read(FS[1], aSize);
      if aSize > 0 then
        Synchronize(@Show);
    end
    else
      Sleep(10);
  end;
end;

end.

